/*
 * Copyright (C) 2025 The Phosh Developers
 * Copyright (C) 2025 Vasiliy Doylov <nekocwd@mainlining.org>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Author: Vasiliy Doylov <nekocwd@mainlining.org>
 * Author: Guido Günther <agx@sigxcpu.org>
 */

using Phosh;
using GLib;

namespace MediaPlayer {
  public class QuickSetting : Phosh.QuickSetting {
    construct {
      var replacer = new Utils.PlayerReplacer ();
      child = replacer;
      visible = false;
      replacer.player.bind_settings (Preferences.Keys.CHILD_QUICK_SETTINGS);
    }
  }
  public class LockScreen : Gtk.Box {
    construct {
      var replacer = new Utils.PlayerReplacer ();
      add (replacer);
      add (new Gtk.Label ("That's a placeholder label.\nYour player now replaced") {
        visible = true,
        wrap = true,
        name = "placeholder-label",
        halign = Gtk.Align.CENTER,
      });
      halign = Gtk.Align.CENTER;

      visible = true;
      replacer.player.bind_settings (Preferences.Keys.CHILD_LOCK_SCREEN);
    }
  }
}
