/*
 * Copyright (C) 2025 Vasiliy Doylov <nekocwd@mainlining.org>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Author: Vasiliy Doylov <nekocwd@mainlining.org>
 */

namespace MediaPlayer.Preferences {
  [CCode (cname = "g_io_module_load")]
  public static void stub (IOModule module) {
    module.use ();
    if (typeof (Preferences) == 0) {
      init (module);
    }

    IOExtensionPoint.implement ("phosh-quick-setting-widget-prefs",
                                typeof (QuickSettings),
                                "media-player-prefs",
                                10);
    IOExtensionPoint.implement ("phosh-lockscreen-widget-prefs",
                                typeof (LockScreen),
                                "media-player-prefs",
                                10);
  }

  [ModuleInit]
  [CCode (cname = "g_module_load_real")]
  /*
   * Weird hack.
   * Move this attribute to stub and see what will happen
   * We don't need to register type on all loads.
   * In `stub` we're checking if any our types was registred if no, call module init
   */
  public static void init (IOModule module) {
  }

  [CCode (cname = "g_io_module_unload")]
  public static void unload (IOModule module) {
  }

  [CCode (cname = "g_io_phosh_plugin_prefs_media_player_query", array_null_terminated = true, array_length = false)]
  public static string[] query () {
    return { "phosh-quick-setting-widget-prefs", "phosh-lockscreen-widget-prefs" };
  }
}
