[GtkTemplate(ui = "/mobi/phosh/plugins/media-player/prefs.ui")]
public class MediaPlayer.Preferences.Preferences : Adw.PreferencesDialog {
  [GtkChild]
  private unowned Gtk.Adjustment adj_margin_top;
  [GtkChild]
  private unowned Gtk.Adjustment adj_margin_bottom;
  [GtkChild]
  private unowned Gtk.Adjustment adj_margin_start;
  [GtkChild]
  private unowned Gtk.Adjustment adj_margin_end;


  protected void bind_preferences(string key) {
    title = key;
    var settings = new Settings.with_path(Keys.SCHEMA_ID, Keys.SETTINGS_PATH);
    settings = settings.get_child(key);
    /*
     * Margins
     */
    settings.bind(Keys.MARGIN_TOP, adj_margin_top, "value", SettingsBindFlags.DEFAULT);
    settings.bind(Keys.MARGIN_BOTTOM, adj_margin_bottom, "value", SettingsBindFlags.DEFAULT);
    settings.bind(Keys.MARGIN_START, adj_margin_start, "value", SettingsBindFlags.DEFAULT);
    settings.bind(Keys.MARGIN_END, adj_margin_end, "value", SettingsBindFlags.DEFAULT);
  }
}

public class MediaPlayer.Preferences.QuickSettings : Preferences {
  construct {
    bind_preferences(Keys.CHILD_QUICK_SETTINGS);
  }
}

public class MediaPlayer.Preferences.LockScreen : Preferences {
  construct {
    bind_preferences(Keys.CHILD_LOCK_SCREEN);
  }
}
